library(rPraat)
library(readxl)
library(tidyverse)

inputFolder <- "."
listFiles <- list.files(path = inputFolder, pattern = "\\.wav$" , ignore.case = TRUE)

tab <- data.frame(file = listFiles,   # table with file names and empty results
                  duration = NA)
tab <- tab %>% separate(file, into = c("file", NA), sep = "\\.")  # odstranění přípony

for (I in seq_along(listFiles)) {
    file <- listFiles[I]
    fileSound <- paste0(inputFolder, "/", file)
    cat(file, "\n")
    
    snd <- snd.read(fileSound)
    tab$duration[I] <- snd$duration  #  + 0.500 přidáme 500 ms pauzu na konci
}

seznam <- read_excel("tab_items.xlsx")
tabPachatel <- tab %>% filter(file %in% seznam$pachatel)

tabulka <- left_join(seznam, tabPachatel %>% rename(pachatel = file), by = "pachatel") %>% rename(durPachatel = duration)
tabulka$dur1 <- NA
tabulka$dur2 <- NA
tabulka$dur3 <- NA
tabulka$dur4 <- NA
tabulka$dur5 <- NA
for (I in 1:nrow(tabulka)) {
    tabulka$dur1[I] <- (tab %>% filter(file == tabulka$podezřelý_1[I]))$duration
    tabulka$dur2[I] <- (tab %>% filter(file == tabulka$podezřelý_2[I]))$duration
    tabulka$dur3[I] <- (tab %>% filter(file == tabulka$podezřelý_3[I]))$duration
    tabulka$dur4[I] <- (tab %>% filter(file == tabulka$podezřelý_4[I]))$duration
    tabulka$dur5[I] <- (tab %>% filter(file == tabulka$podezřelý_5[I]))$duration
}


fileName <- "vystup.txt"
fid <- file(fileName, open = "w", encoding = "UTF-8")
if (!isOpen(fid)) {
    stop(paste0("cannot open file [", fileName, "]"))
}
for (I in seq_along(tabulka$pachatel)) {
    writeLines(paste0("  ", tabulka$pachatel[I], "\t\"", tabulka$pachatel[I], "\"\t", ceiling(tabulka$durPachatel[I]*1000), "\t",
                      tabulka$podezřelý_1[I], "\t",
                      tabulka$podezřelý_2[I], "\t",
                      tabulka$podezřelý_3[I], "\t",
                      tabulka$podezřelý_4[I], "\t",
                      tabulka$podezřelý_5[I], "\t",
                      ceiling(tabulka$dur1[I]*1000), "\t",
                      ceiling(tabulka$dur2[I]*1000), "\t",
                      ceiling(tabulka$dur3[I]*1000), "\t",
                      ceiling(tabulka$dur4[I]*1000), "\t",
                      ceiling(tabulka$dur5[I]*1000)), fid)
}
close(fid)

write.table(tabulka %>% select(pachatel:podezřelý_5) %>% unlist(), "vystup2.txt", row.names = FALSE, quote = FALSE)
